#include <stdio.h>
#include <sys/types.h>
// #include <sys/socket.h>
#include <winsock2.h>
#pragma comment(lib,"wsock32.lib") //ws2_32.lib
//#include <netinet/in.h>

#include <time.h>

enum Algo {
	BLAKE = 0,
	BMW,
	GROESTL,
	JH,
	KECCAK,
	SKEIN,
	LUFFA,
	CUBEHASH,
	SHAVITE,
	SIMD,
	ECHO,
	HAMSI,
	FUGUE,
	SHABAL,
	WHIRLPOOL,
	SHA512,
	HASH_FUNC_COUNT
};

static const char* algo_strings[] = {
	"blake",
	"bmw512",
	"groestl",
	"jh512",
	"keccak",
	"skein",
	"luffa",
	"cube",
	"shavite",
	"simd",
	"echo",
	"hamsi",
	"fugue",
	"shabal",
	"whirlpool",
	"sha512",
	NULL
};

void timeprint(char *str)
{
	const time_t now = time(NULL);
		char fbuf[256];
		int len;
		struct tm tm, *ptm;

		ptm = localtime(&now);
	tm = *ptm;
		printf("[%d-%02d-%02d %02d:%02d:%02d] %s\n",
			tm.tm_year + 1900,
			tm.tm_mon + 1,
			tm.tm_mday,
			tm.tm_hour,
			tm.tm_min,
			tm.tm_sec,
			str
		);
}
int
main()
{
 int sock0;
 struct sockaddr_in addr;
 struct sockaddr_in client;
 int len;
 int sock;
	int sz;
		time_t told, tnow = time(NULL);
		char fbuf[256];
		struct tm tm;


	char lbuf[1024];
	char sbuf[4096];
	int sendCnt = 0;
	int recvCnt = 0;
	unsigned int hex1, hex2;

	
int rc;
 WSADATA wsaData;

 WSAStartup(MAKEWORD(2,0), &wsaData);
	
	/* \Pbg̍쐬 */
 sock0 = socket(AF_INET, SOCK_STREAM, 0);

 /* \Pbg̐ݒ */
 addr.sin_family = AF_INET;
 addr.sin_port = htons(12345);
 addr.sin_addr.s_addr = INADDR_ANY;//htonl(INADDR_LOOPBACK);
 rc = bind(sock0, (struct sockaddr *)&addr, sizeof(addr));
	if( rc < 0) {
		printf("rc=%d\n", rc);
		     printf("error : %d\n", WSAGetLastError());
		exit(1);
	}

 /* TCPNCAg̐ڑv҂ĂԂɂ */
 rc = listen(sock0, 5);
	if( rc < 0) {
		printf("rc=%d\n", rc);
		     printf("error : %d\n", WSAGetLastError());
		exit(1);
	}

 /* TCPNCAg̐ڑv󂯕t */
 len = sizeof(client);
 sock = accept(sock0, (struct sockaddr *)&client, &len);
	if( sock < 0) {
		printf("sock=%d\n", sock);
				     printf("error : %d\n", WSAGetLastError());
		exit(1);

	}
	printf("sock=%d\n", sock);
	
	
	while(sendCnt < 3)
	{
		sz = recv(sock, lbuf, sizeof(lbuf), 0);
		if( sz == 0)
		{
			Sleep(500);
			continue;
		}
		if( sz < 0)
		{
			break;
		}
		lbuf[sz] = 0;
		printf("sz=%d,%s\n", sz, lbuf);
		switch(sendCnt++)
		{
		case 0:
			sprintf(sbuf, "{\"id\":1,\"error\":null,\"result\":[[\"mining.notify\",\"8f53a0baae87434504a47ce3393e66ca\"],\"8100414b55\",3]}");
			break;
		case 1:
			sprintf(sbuf, "{\"id\":2,\"result\":true,\"error\":null}");
			break;
		case 2:
			sprintf(sbuf, "{\"id\":3,\"result\":true,\"error\":null}");
			break;
		case 3:
			sprintf(sbuf, "{\"id\":null,\"method\":\"mining.set_difficulty\",\"params\":[8]}");
			break;
		case 4:
			sprintf(sbuf, "\
				{\"params\":[\"000000f0a3526686\"\
,\"54fc0115bea18fd990b32e9be2e67399d94c42d34e6fb3590000f15d00000000\"\
,\"02000000010000000000000000000000000000000000000000000000000000000000000000ffffffff430314da05045c87b05b08\"\
,\"7a65726700fabe6d6d812420b04e0c0870038d92869ac627f171e37d19b73399d1f8468be32ab5d4fe010000000000000000000000010088526a740000001976a914a31093b45f552e3f58d1af381e430661c5eccf2b88ac00000000\"\
,[]\
,\"20000000\"\
,\"1b01efdf\"\
,\"5bb0875c\"\
,true]\
,\"id\":null,\"method\":\"mining.notify\"}\
");
			break;
		default:
			break;
		
		}
		strcat(sbuf, "\n");
		send(sock, sbuf, strlen(sbuf), 0);
		sbuf [0] = 0;
	}
	Sleep(500);
	sprintf(sbuf, "{\"id\":null,\"method\":\"mining.set_difficulty\",\"params\":[8]}");
	strcat(sbuf, "\n");
	send(sock, sbuf, strlen(sbuf), 0);
	sbuf [0] = 0;
	Sleep(500);

		hex1 = 0x01234567;
		hex2 = 0x89abcdef;
	
	sprintf(sbuf, "\
	{\"params\":[\"000000f0a3526686\"\
,\"%08x%08x90b32e9be2e67399d94c42d34e6fb3590000f15d00000000\"\
,\"02000000010000000000000000000000000000000000000000000000000000000000000000ffffffff430314da05045c87b05b08\"\
,\"7a65726700fabe6d6d812420b04e0c0870038d92869ac627f171e37d19b73399d1f8468be32ab5d4fe010000000000000000000000010088526a740000001976a914a31093b45f552e3f58d1af381e430661c5eccf2b88ac00000000\"\
,[]\
,\"20000000\"\
,\"1b01efdf\"\
,\"5bb0875c\"\
,true]\
,\"id\":null,\"method\":\"mining.notify\"}\
", hex1, hex2);
		strcat(sbuf, "\n");
		send(sock, sbuf, strlen(sbuf), 0);
		sbuf [0] = 0;
	 	timeprint("SEND mining.notify");
	told = time(NULL);
	while(1)
	{
		char *ptr;
		char *ptr2;
		
		sz = recv(sock, lbuf, sizeof(lbuf), 0);
		if( sz == 0)
		{

			Sleep(100);
			continue;
		}
		if( sz < 0)
		{
			break;
		}
		lbuf[sz] = 0;
//		printf("sz=%d,%s\n", sz, lbuf);
		if( strstr(lbuf, "mining.submit") == NULL)
		{
			continue;
		}

		
		ptr = strstr(lbuf, "\"id\"");
		ptr2 = strchr(ptr, '}');
		*ptr2 = 0;
		
		sprintf(sbuf, "{%s,\"result\":true,\"error\":null}", ptr);
		
		
//		{"id":10,"result":true,"error":null}
		
		strcat(sbuf, "\n");
		send(sock, sbuf, strlen(sbuf), 0);
		sbuf [0] = 0;
		
		if( recvCnt == 0)
		{
			tnow = time(NULL);
			timeprint("START");
			told=tnow;
		}
		recvCnt++;
		
		if( recvCnt <= 10)
		{
			printf("+"); fflush(stdout);
		}
		else
		{
			tnow = time(NULL);

			printf("\n");
			
			if( hex1 == 0x01234567)
			{
				printf("ALGO: MIX1");
				hex1 = 0xfedcba98;
				hex2 = 0x76543210;
			}
			else
			if( hex1 == 0xfedcba98)
			{
				printf("ALGO: MIX2");
				hex1 = hex2 = 0x0;
			}
			else
			{
				printf("ALGO: %s",  algo_strings[hex1 & 0xf]);
				hex1 += 0x11111111;
				hex2 += 0x11111111;
			}
			printf(" Count=%d, time=%d sec\n", recvCnt - 1, tnow-told);
			timeprint("END");
			recvCnt = 0;
	
	sprintf(sbuf, "\
	{\"params\":[\"000000f0a3526686\"\
,\"%08x%08x90b32e9be2e67399d94c42d34e6fb3590000f15d00000000\"\
,\"02000000010000000000000000000000000000000000000000000000000000000000000000ffffffff430314da05045c87b05b08\"\
,\"7a65726700fabe6d6d812420b04e0c0870038d92869ac627f171e37d19b73399d1f8468be32ab5d4fe010000000000000000000000010088526a740000001976a914a31093b45f552e3f58d1af381e430661c5eccf2b88ac00000000\"\
,[]\
,\"20000000\"\
,\"1b01efdf\"\
,\"5bb0875c\"\
,true]\
,\"id\":null,\"method\":\"mining.notify\"}\
", hex1, hex2);
			strcat(sbuf, "\n");
			send(sock, sbuf, strlen(sbuf), 0);
			sbuf [0] = 0;
		}
		
	}	
	
	Sleep(10000);
 /* 5M */
// write(sock, "HELLO", 5);

 /* TCPZbV̏I */
 closesocket(sock);

 /* listen socket̏I */
 closesocket(sock0);

	
 return 0;
}
